/******************** (C) COPYRIGHT 2006 STMicroelectronics ********************
* File Name          : Init_Module.h
* Author             : MCD Application Team
* Date First Issued  : 08/12/06
* Description        : This file provides prototypes for functions in 
*                       Init_Module.c
********************************************************************************
* History:
* 08/12/2006 :  Version 1.0
********************************************************************************
* THE PRESENT SOFTWARE WHICH IS FOR GUIDANCE ONLY AIMS AT PROVIDING CUSTOMERS
* WITH CODING INFORMATION REGARDING THEIR PRODUCTS IN ORDER FOR THEM TO SAVE TIME.
* AS A RESULT, STMICROELECTRONICS SHALL NOT BE HELD LIABLE FOR ANY DIRECT,
* INDIRECT OR CONSEQUENTIAL DAMAGES WITH RESPECT TO ANY CLAIMS ARISING FROM THE
* CONTENT OF SUCH SOFTWARE AND/OR THE USE MADE BY CUSTOMERS OF THE CODING
* INFORMATION CONTAINED HEREIN IN CONNECTION WITH THEIR PRODUCTS.
*******************************************************************************/

#ifndef _INIT_MODULE_H
#define _INIT_MODULE_H

/* Includes ------------------------------------------------------------------*/
#include <REG276.h>
#include "LibST10.h"

/* Defines -------------------------------------------------------------------*/
#define     FIR_ORDER       14   /* Filter's order */
#define     NB_FIR_COEFF    15	 /* Filter coefficients number */
#define     NB_OUTPUT        1   /* Filter output samples number */

/* Functions Prototypes-------------------------------------------------------*/
/*******************************************************************************
* Function Name  : ADC_Init
* Description    : Initailzes the ADC module
* Input          : None.
* Output         : None.
* Return         : None.
*******************************************************************************/
void ADC_Init( void );

/*******************************************************************************
* Function Name  : PWM_Init
* Description    : Initailzes the PWM module which is used as 8-bit DAC
* Input          : None.
* Output         : None.
* Return         : None.
*******************************************************************************/
void PWM_Channel0_Init( void );

/*******************************************************************************
* Function Name  : FIR_Init
* Description    : Initailzes a filter structure with the following paramters
*                : Filter's number of coeff = NB_FIR_COEFF
*                : One output sample computed 
*                : Table of coeff's coeff = FIR_COEFF 
*                : Number of input samples = NB_FIR_COEFF 
* Input          : Pointer on a Filter structure .
* Output         : None.
* Return         : None.
*******************************************************************************/
void FIR_Init( struct Filter _iram *fir);

#endif

/************************ (c) 2006  ST Microelectronics ******* END OF FILE ***/
