/******************** (C) COPYRIGHT 2006 STMicroelectronics ********************
* File Name          : main.c
* Author             : MCD Application Team
* Date First Issued  : 08/12/06
* Description        : This file provides the main program of the filter example 
*                      No interrupts are used in the example( polling ex) 
********************************************************************************
* History:
* 08/12/2006 :  Version 1.0
********************************************************************************
* THE PRESENT SOFTWARE WHICH IS FOR GUIDANCE ONLY AIMS AT PROVIDING CUSTOMERS
* WITH CODING INFORMATION REGARDING THEIR PRODUCTS IN ORDER FOR THEM TO SAVE TIME.
* AS A RESULT, STMICROELECTRONICS SHALL NOT BE HELD LIABLE FOR ANY DIRECT,
* INDIRECT OR CONSEQUENTIAL DAMAGES WITH RESPECT TO ANY CLAIMS ARISING FROM THE
* CONTENT OF SUCH SOFTWARE AND/OR THE USE MADE BY CUSTOMERS OF THE CODING
* INFORMATION CONTAINED HEREIN IN CONNECTION WITH THEIR PRODUCTS.
*******************************************************************************/

/* Includes ------------------------------------------------------------------*/
#include "Init_Module.h"


void main( void )																																																	                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                 
{
    unsigned int i=0;
    unsigned int position=0;
    short Input_buffer[2*NB_FIR_COEFF];
    struct Filter FIR;
	   	    	
    /* Enable Saturation and automatic shift */    	 		
    MCW = 0x600;
	
    /* PWM Channel 0 initialization */
    PWM_Channel0_Init();
				 				   	   			   
    /* ADC module Initialization */
    ADC_Init();	
	
    /* FIR structure Initialization */    					   	 			
    FIR_Init(&FIR);

    /* wait until PIR0 = 1 to start the first sampling */ 
    while( !PIR0);
    PEN0 = 1;
						
    for(;;)
    {	 		   	
      /* wait until PIR0 is set */
      while( !PIR0);

      /* Clear PWM interrupt requests */
      PWMIR = 0;
      PIR0 = 0;

      /* Start conversion */
      ADST = 1;

      /* Wait until the conversion is completed */
      while( !ADCIR);

      /* Clear The ADCIR interrupt request */ 
      ADCIR = 0;

      /* Store the input sample in the input buffer samples */
      position = position % NB_FIR_COEFF;
      Input_buffer[position] = ADDAT;
      Input_buffer[position + NB_FIR_COEFF] = ADDAT;
      FIR.InputPtr = &Input_buffer[position];

      /* applicate the filter */
      fir_q15_q15_q15(&FIR); 
      position++;		

      /* Digital to Analog conversion */
      PW0 = PP0 +1 - ( FIR.OutputPtr[0] >> 7);
      	
    }  /*end 4 ever */ 					  
} 
	  

/************************ (c) 2006  ST Microelectronics ******* END OF FILE ***/

  
    












